plugin simpleObject Vu_Honeycomb
	name:"Vu_Honeycomb"
	classID:#(0x42D50008, 0x63AD49BF)
	category:"Max Creation Graph"
(
	local pluginDefinitionFile -- the plugin definition file
	local pluginInstance -- the plugin instance created from the plugin definition
	local _meshWrapper -- the dotnet wrapper around our mesh pointer
	local argsType = dotNetClass "System.Object[]" -- used when creating args array
	local dotnet_ValueToDotNetObject = dotnet.ValueToDotNetObject
	local tmHandler
	local owningNode

	-- function wrappers
	local _meshWrapper_SetValue
	local pluginInstance_UpdateMesh

	-- value wrapper local and function wrapper declarations


	parameters main rollout:params
	(
		Rings ui:Rings default:1 type:#integer animatable:true
		HeightSegs ui:HeightSegs default:1 type:#integer animatable:true
		Radius ui:Radius default:5 type:#float animatable:true
		Height ui:Height default:2 type:#float animatable:true
		Rows ui:Rows default:6 type:#integer animatable:true
		Gap ui:Gap default:0 type:#float animatable:true
		Cols ui:Cols default:6 type:#integer animatable:true
		_dummy type:#boolean -- this exists to enable easy invalidation of the object        
        pluginGraph type:#filename assettype:#MaxCreationGraph readOnly:true enumAsAsset:true 
        pluginGraphDependencies type:#filenametab assettype:#MaxCreationGraph readOnly:true enumAsAsset:true tabSize:0 tabSizeVariable:true
    ) 

rollout params "Parameters"
	(
		spinner Radius "Radius" range:[0, 100, 5] type:#float
		spinner Rows "Rows" range:[0, 100, 6] type:#integer
		spinner Cols "Cols" range:[0, 100, 6] type:#integer
		spinner Rings "Rings" range:[1, 9, 1] type:#integer
		spinner Gap "Gap" range:[-999, 999, 0] type:#float

		spinner Height "Height" range:[0, 100, 2] type:#float
		spinner HeightSegs "HeightSegs" range:[1, 100, 1] type:#integer
	)
rollout inforoll "About"
	(
		Group "Vu Honeycomb Info"
		(
			label lab91 "Author: Vu Nguyen" align:#left
			label lab92 "(c) Vu Nguyen 2015" align:#left
			label lab94 "Version: 2.00.00" align:#left
			label lab95 "Email: vusta@hotmail.com" align:#left
		)

	)

	fn initialize = 
	(
		pluginDefinitionFile = @"C:/Users/Honey/Autodesk/3ds Max 2016/Max Creation Graph/Tools/Vu_Honeycomb.maxtool"
		local c = dotNetClass "Viper3dsMaxBridge.GeometryPluginInstance"
		local cid = this.classId
		local refMakerWrapperClass = dotnetclass "Autodesk.Max.MaxPlus.ReferenceMaker"
		local _pluginOwner = refMakerWrapperClass._CreateWrapper this
		pluginInstance = c.CreateInstance cid[1] cid[2] pluginDefinitionFile _pluginOwner
		pluginInstance_UpdateMesh = pluginInstance.UpdateMesh
		local meshWrapperClass = dotnetclass "Autodesk.Max.MaxPlus.Mesh"
		_meshWrapper = meshWrapperClass._CreateWrapper undefined
		_meshWrapper_SetValue = _meshWrapper._SetValue
		pluginGraph = pluginDefinitionFile
		pluginGraphDependencies = #(@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\SkipOne.maxcompound",@"C:\Users\Honey\Autodesk\3ds Max 2016\Max Creation Graph\Compounds\CircleOfPoints.maxcompound",@"C:\Users\Honey\Autodesk\3ds Max 2016\Max Creation Graph\Compounds\CircularArcOfPointsFix.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\RangeInclusiveFloatTo.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\RangeExclusiveFloatTo.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\RotatePoint.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\Extrude.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\PlusOne.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\MovePoints.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\MapRange.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\ToTriMesh.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\HideEveryThirdEdge.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\ModuloEquals.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\MeshBoundingBox.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\BoundingBoxExtent.maxcompound",@"C:\Users\Honey\Autodesk\3ds Max 2016\Max Creation Graph\Tools\Downloads\MultiSlice\Compounds\VectorValueAtIndex.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\VectorAsArray.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\Array3.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\OffsetMeshes.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\OffsetMesh.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\DeformMeshPoints.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\MapWithIndexes.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\DivideByTwoFloat.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\MinusOne.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\ArrayFromToStep.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\SelectByIndex.maxcompound")

		-- value wrapper local initializations

	)


	fn updateMesh = 
	(
		if (pluginInstance == undefined) then ( return undefined )
		local args = dotnet_ValueToDotNetObject #(Rings, HeightSegs, Radius, Height, Rows, Gap, Cols) argsType
		pluginInstance_UpdateMesh (currentTime as integer) _meshWrapper args
	)

	on buildMesh do
	(
		try 
		(
			_meshWrapper_SetValue mesh

			updateMesh()
			_meshWrapper_SetValue undefined

		)
		catch()
		ok
	)

	on create do 
	(
		initialize()
	)

	on clone fromObj do 
	(
		initialize()
	)

	on load do 
	(
		initialize()
	)

	on update do 
	(
		initialize()
	)



	tool create 
	(
		on mousePoint click do 
		(
			case click of 
			(
				1: nodeTM.translation = gridPoint
				2: #stop
			) 
		) 
	) 
)
